package com.example.demo.controller;

import com.alibaba.fastjson.JSON;

import com.example.demo.entity.Additive;
import com.example.demo.entity.Sheet;

import com.example.demo.service.AdditiveService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


@RestController
@RequestMapping(value = "/CRUD", method = { RequestMethod.GET, RequestMethod.POST })
public class AdditiveController {
    @RequestMapping("/match1")
    @ResponseBody
    public String Match1(String food_sort_no,String food_name){
        String json1= JSON.toJSONString(additiveService.match(food_name,food_sort_no));
        return json1;
    }
    @Autowired
    private AdditiveService additiveService;
    @RequestMapping("/ListAdditive")
    @ResponseBody
    public List<Additive> ListAddictiveByName(){
        return additiveService.ListAdditive();
    }
    //对数据库进行查找操作
    @RequestMapping("/ListAdditiveByName")
    @ResponseBody
    public List<Additive> ListUserByAddictiveByName(String additiveCname, String foodSortNo){
        return additiveService.findByName(additiveCname,foodSortNo);
    }

    //对数据库进行的删除操作
    @RequestMapping(value = "/deleteAdditiveByName", method = RequestMethod.GET)
    public String delete(Additive additive) {
        String json1= JSON.toJSONString("删除成功");
        String json2= JSON.toJSONString("删除失败");
        int result = additiveService.Update2(additive);
        if (result >= 1) {
            return json1;
        } else {
            return json2;
        }
    }
    //对数据进行修改的操作
    @RequestMapping(value = "/updateAdditiveByName", method = RequestMethod.GET)
    public String update(Additive additive) {
        String json1= JSON.toJSONString("修改成功");
        String json2= JSON.toJSONString("修改失败");
        if (additive.getAdditiveCname()==null)
        {
            additive.setAdditiveCname("");
        }
        if (additive.getAdditiveEname()==null)
        {
            additive.setAdditiveEname("");
        }
        if (additive.getFoodCname()==null)
        {
            additive.setFoodCname("");
        }
        if (additive.getFoodEname()==null)
        {
            additive.setFoodEname("");
        }
        if (additive.getCnsNo()==null)
        {
            additive.setCnsNo("");
        }
        if (additive.getInsNo()==null)
        {
            additive.setInsNo("");
        }
        if (additive.getCountryPlace()==null)
        {
            additive.setCountryPlace("");
        }
        if (additive.getFoodSortNo()==null)
        {
            additive.setFoodSortNo("");
        }
        if (additive.getMaxUsage()==null)
        {
            additive.setMaxUsage("");
        }
        if (additive.getFunction()==null)
        {
            additive.setFunction("");
        }
        if (additive.getInformationSources()==null)
        {
            additive.setInformationSources("");
        }
        if (additive.getSortExplain()==null)
        {
            additive.setSortExplain("");
        }
        if (additive.getRemarks()==null)
        {
            additive.setRemarks("");
        }

        int result = additiveService.Update(additive);
        if (result >= 1) {
            return json1;
        } else {
            return json2;
        }
    }
    //对数据库进行增加字段操作
    @RequestMapping(value = "/insertAdditiveByName", method = RequestMethod.GET)
    public int insert(Additive additive)
    {
        if (additive.getAdditiveCname()==null)
        {
            additive.setAdditiveCname("");
        }
        if (additive.getAdditiveEname()==null)
        {
            additive.setAdditiveEname("");
        }
        if (additive.getFoodCname()==null)
        {
            additive.setFoodCname("");
        }
        if (additive.getFoodEname()==null)
        {
            additive.setFoodEname("");
        }
        if (additive.getCnsNo()==null)
        {
            additive.setCnsNo("");
        }
        if (additive.getInsNo()==null)
        {
            additive.setInsNo("");
        }
        if (additive.getCountryPlace()==null)
        {
            additive.setCountryPlace("");
        }
        if (additive.getFoodSortNo()==null)
        {
            additive.setFoodSortNo("");
        }
        if (additive.getMaxUsage()==null)
        {
            additive.setMaxUsage("");
        }
        if (additive.getFunction()==null)
        {
            additive.setFunction("");
        }
        if (additive.getInformationSources()==null)
        {
            additive.setInformationSources("");
        }
        if (additive.getSortExplain()==null)
        {
            additive.setSortExplain("");
        }
        if (additive.getRemarks()==null)
        {
            additive.setRemarks("");
        }
        return additiveService.insertAdditive(additive);
    }

    //导入表到库
 /*   @RequestMapping(value ="/aa", method = RequestMethod.GET )
    public void  read()
    {
        try {
            List<PollutantLimit> aa = Readpollutant.read("C:\\测试表格3.xlsx");
            System.out.println(aa.size());
            for (int i = 0; i < aa.size(); i++) {
                insert(aa.get(i));
            }
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

  */

    @RequestMapping("/getAdditiveCategory")
    public List<Sheet> getSheet(){
        return additiveService.getSheet();
    }

}