package com.example.demo.controller;

import com.alibaba.fastjson.JSON;
import com.example.demo.entity.Base;
import com.example.demo.entity.FungimycinLimit;
import com.example.demo.entity.Static;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.util.List;
import java.util.UUID;

@Controller
public class FungimycinUploadController {
    @Autowired
    FuncimycinController crud=new FuncimycinController();

    /**
     * 初始化上传文件界面，跳转到index.jsp
     * @return
     */
    @RequestMapping(value = "/CRUD/index",method = RequestMethod.GET)
    public String index(){
        return "index";
    }

    /**
     * 提取上传方法为公共方法
     * @param uploadDir 上传文件目录
     * @param file 上传对象
     * @throws Exception
     */
    private void executeUpload(String uploadDir,MultipartFile file) throws Exception
    {
        //文件后缀名
        String suffix = file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
        //上传文件名
        String filename = UUID.randomUUID() + suffix;
        //服务器端保存的文件对象
        File serverFile = new File(uploadDir + filename);
        //将上传的文件写入到服务器端文件内
        file.transferTo(serverFile);
    }

    //void read();

    /**
     * 上传文件方法
     * @param file 前台上传的文件对象
     * @return
     */
    @RequestMapping(value = "/CRUD/FungimycinUpload",method = RequestMethod.POST)
    public @ResponseBody Base upload(HttpServletRequest request,MultipartFile file)
    {
        int success = 0;
        int lose = 0;
        String record ="";
        Base base = new Base();
        Static static1=new Static();
        String json1= JSON.toJSONString("修改成功");
        String json2= JSON.toJSONString("修改失败");
        try {
            //上传目录地址
            String uploadDir = request.getSession().getServletContext().getRealPath("/") +"upload\\";
            //如果目录不存在，自动创建文件夹
            File dir = new File(uploadDir);
            if(!dir.exists())
            {
                dir.mkdir();
            }
            //调用上传方法
            //文件后缀名
            String suffix = file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
            //上传文件名
            String filename = UUID.randomUUID() + suffix;
            //服务器端保存的文件对象
            File serverFile = new File(uploadDir + filename);
            //将上传的文件写入到服务器端文件内
            file.transferTo(serverFile);
            try {
                List<FungimycinLimit> aa = ReadFungimycin.read(""+uploadDir+filename.replace("/","\\"));
                for (int i = 0; i < aa.size(); i++) {
                    if(crud.insert(aa.get(i))==1){
                        success++;
                    }
                    else{
                        lose++;
                        String str = String.valueOf(i+1);
                        record = record +","+ str;
                    }
                }
                static1.setLose(lose);
                static1.setSuccess(success);
                static1.setRecord1(record.substring(1));
            } catch(Exception e){
                System.out.println(e.getMessage());

            }
        }catch (Exception e)
        {
            //打印错误堆栈信息
            System.out.println(e.getMessage());
            base.setCode("错误代码");
            base.setMessage("错误信息");
            base.setSuccess(false);
            return base;
        }
        base.setDataobject(static1);
        base.setMessage("成功信息");
        base.setSuccess(true);
        base.setCode("成功");
        return base;
    }

}
