package com.example.demo.controller;

import com.alibaba.fastjson.JSON;
import com.example.demo.entity.FungimycinLimit;
import com.example.demo.entity.PesticidesLimit;
import com.example.demo.entity.Sheet;
import com.example.demo.service.PesticidesLimitService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


@RestController
@RequestMapping(value = "/CRUD", method = { RequestMethod.GET, RequestMethod.POST })
public class PesticidesController {
    @Autowired
    private PesticidesLimitService pesticidesLimitService;
    @RequestMapping("/ListPesticides")
    @ResponseBody
    public List<PesticidesLimit> ListPesticidesByName(){
        return pesticidesLimitService.ListPesticides();
    }
    //对数据库进行查找操作
    @RequestMapping("/ListPesticidesByName")
    @ResponseBody
    public List<PesticidesLimit> ListUserByPesticidesByName(String pesticidesCname, String food_sort_no){
        return pesticidesLimitService.findByName(pesticidesCname,food_sort_no);
    }

    //对数据库进行的删除操作
    @RequestMapping(value = "/deletePesticidesByName", method = RequestMethod.GET)
    public String delete(PesticidesLimit pesticidesLimit) {
        String json1= JSON.toJSONString("删除成功");
        String json2= JSON.toJSONString("删除失败");
        int result = pesticidesLimitService.Update2(pesticidesLimit);
        if (result >= 1) {
            return json1;
        } else {
            return json2;
        }
    }
    //对数据进行修改的操作
    @RequestMapping(value = "/updatePesticidesByName", method = RequestMethod.GET)
    public String update(PesticidesLimit pesticidesLimit) {
        String json1= JSON.toJSONString("修改成功");
        String json2= JSON.toJSONString("修改失败");
        if(pesticidesLimit.getAdi()==null){
            pesticidesLimit.setAdi("");
        }
        if(pesticidesLimit.getCheckWay()==null){
            pesticidesLimit.setCheckWay("");
        }
        if(pesticidesLimit.getCountryPlace()==null){
            pesticidesLimit.setCountryPlace("");
        }
        if(pesticidesLimit.getDeterminePlace()==null){
            pesticidesLimit.setDeterminePlace("");
        }
        if(pesticidesLimit.getFoodName() ==null){
            pesticidesLimit.setFoodName("");
        }
        if(pesticidesLimit.getInformationSources()==null){
            pesticidesLimit.setInformationSources("");
        }
        if(pesticidesLimit.getLimited()==null){
            pesticidesLimit.setLimited("");
        }
        if(pesticidesLimit.getMainUses()==null){
            pesticidesLimit.setMainUses("");
        }
        if(pesticidesLimit.getPesticidesCname()==null){
            pesticidesLimit.setPesticidesCname("");
        }
        if(pesticidesLimit.getPesticidesEname()==null){
            pesticidesLimit.setPesticidesEname("");
        }
        if(pesticidesLimit.getRemarks()==null){
            pesticidesLimit.setRemarks("");
        }
        if(pesticidesLimit.getResidue()==null){
            pesticidesLimit.setResidue("");
        }

        int result = pesticidesLimitService.Update(pesticidesLimit);
        if (result >= 1) {
            return json1;
        } else {
            return json2;
        }
    }
    //对数据库进行增加字段操作
    @RequestMapping(value = "/insertPesticidesByName", method = RequestMethod.GET)
    public int insert(PesticidesLimit pesticidesLimit)
    {
        if(pesticidesLimit.getAdi()==null){
            pesticidesLimit.setAdi("");
        }
        if(pesticidesLimit.getCheckWay()==null){
            pesticidesLimit.setCheckWay("");
        }
        if(pesticidesLimit.getCountryPlace()==null){
            pesticidesLimit.setCountryPlace("");
        }
        if(pesticidesLimit.getDeterminePlace()==null){
            pesticidesLimit.setDeterminePlace("");
        }
        if(pesticidesLimit.getFoodName() ==null){
            pesticidesLimit.setFoodName("");
        }
        if(pesticidesLimit.getInformationSources()==null){
            pesticidesLimit.setInformationSources("");
        }
        if(pesticidesLimit.getLimited()==null){
            pesticidesLimit.setLimited("");
        }
        if(pesticidesLimit.getMainUses()==null){
            pesticidesLimit.setMainUses("");
        }
        if(pesticidesLimit.getPesticidesCname()==null){
            pesticidesLimit.setPesticidesCname("");
        }
        if(pesticidesLimit.getPesticidesEname()==null){
            pesticidesLimit.setPesticidesEname("");
        }
        if(pesticidesLimit.getRemarks()==null){
            pesticidesLimit.setRemarks("");
        }
        if(pesticidesLimit.getResidue()==null){
            pesticidesLimit.setResidue("");
        }

        return pesticidesLimitService.insertPesticidesLimit(pesticidesLimit);
    }

    //导入表到库
 /*   @RequestMapping(value ="/aa", method = RequestMethod.GET )
    public void  read()
    {
        try {
            List<PollutantLimit> aa = Readpollutant.read("C:\\测试表格3.xlsx");
            System.out.println(aa.size());
            for (int i = 0; i < aa.size(); i++) {
                insert(aa.get(i));
            }
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

  */

    @RequestMapping("/getPesticidesCategory")
    public List<Sheet> getSheet(){
        return pesticidesLimitService.getSheet();
    }

}