package com.example.demo.controller;

import com.alibaba.fastjson.JSON;
import com.example.demo.entity.PollutantLimit;
import com.example.demo.entity.Sheet;
import com.example.demo.service.PollutantLimitService;
import org.apache.jasper.tagplugins.jstl.core.If;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;



@RestController
@RequestMapping(value = "/CRUD", method = { RequestMethod.GET, RequestMethod.POST })
public class PollutantController {

    @RequestMapping("/ListUser")
    @ResponseBody
    public List<PollutantLimit> ListUser(){
        return pollutantLimitservice.ListUser();
    }
    //对数据库进行查找操作
    @RequestMapping("/ListPollutantLimitByName")
    @ResponseBody
    public List<PollutantLimit> ListUserByCNofPollutant(String pollutant_cname, String food_sort_no){
        return pollutantLimitservice.findByName(pollutant_cname,food_sort_no);
    }
    @Autowired
    private PollutantLimitService pollutantLimitservice;
    //对数据库进行的删除操作
    @RequestMapping(value = "/delete", method = RequestMethod.GET)
    public String delete(PollutantLimit pollutantLimit) {
        String json1= JSON.toJSONString("删除成功");
        String json2= JSON.toJSONString("删除失败");
        int result = pollutantLimitservice.Update2(pollutantLimit);
        if (result >= 1) {
            return json1;
        } else {
            return json2;
        }
    }
    //对数据进行修改的操作
    @RequestMapping(value = "/update", method = RequestMethod.GET)
    public String update(PollutantLimit pollutantLimit) {
        if(pollutantLimit.getCheck_way()==null)
            pollutantLimit.setCheck_way("");
        if(pollutantLimit.getCountry_place()==null)
            pollutantLimit.setCountry_place("");
        if(pollutantLimit.getFood_name() ==null)
            pollutantLimit.setFood_name("");
        if(pollutantLimit.getFood_sort_no()==null)
            pollutantLimit.setFood_sort_no("");
        if(pollutantLimit.getInformation_sources()==null)
            pollutantLimit.setInformation_sources("");
        if(pollutantLimit.getLimited()==null)
            pollutantLimit.setLimited("");
        if(pollutantLimit.getPollutant_cname()==null)
            pollutantLimit.setPollutant_cname("");
        if(pollutantLimit.getPollutant_ename()==null)
            pollutantLimit.setPollutant_ename("");
        if(pollutantLimit.getRemarks()==null)
            pollutantLimit.setRemarks("");
        if(pollutantLimit.getTips()==null)
            pollutantLimit.setTips("");
        if(pollutantLimit.getDoseUnit()==null)
            pollutantLimit.setDoseUnit("");

        String json1= JSON.toJSONString("修改成功");
        String json2= JSON.toJSONString("修改失败");
        int result = pollutantLimitservice.Update(pollutantLimit);
        if (result==1) {
            return json1;
        } else {
            return json2;
        }
    }
    //对数据库进行增加字段操作
    @RequestMapping(value = "/insert", method = RequestMethod.GET)
    public int insert(PollutantLimit pollutantLimit)
    {

        return pollutantLimitservice.insertPollutantLimit(pollutantLimit);
    }

    //导入表到库
    @RequestMapping(value ="/aa", method = RequestMethod.GET )
    public void  read()
    {
        try {
            List<PollutantLimit> aa = Readpollutant.read("C:\\测试表格3.xlsx");
            System.out.println(aa.size());
            for (int i = 0; i < aa.size(); i++) {
                insert(aa.get(i));
            }
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @RequestMapping("/getCategory")
    public List<Sheet> getSheet(){
        return pollutantLimitservice.getSheet();
    }

}