package com.example.demo.controller;

import com.example.demo.entity.FungimycinLimit;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;


public class ReadFungimycin {


    public static ArrayList<FungimycinLimit> read(String path) throws IOException, InvalidFormatException {
        ArrayList<FungimycinLimit> list = new ArrayList<>();
        System.out.println(path);
        File excel = new File(path);
        if (excel.isFile() && excel.exists()) {   //判断文件是否存在

            String split = excel.getName();


            Workbook wb;
            //根据文件后缀（xls/xlsx）进行判断
            if (split.endsWith(".xls")) {
                FileInputStream fis = new FileInputStream(excel);   //文件流对象
                wb = new HSSFWorkbook(fis);
            } else if (split.endsWith(".xlsx")) {
                wb = new XSSFWorkbook(excel);
            } else {
                System.out.println("文件类型错误!");
                return null;
            }

            //开始解析
            Sheet sheet = wb.getSheetAt(0);     //读取sheet 0

            int firstRowIndex = sheet.getFirstRowNum() + 1;   //第一行是列名，所以不读
            int lastRowIndex = sheet.getLastRowNum();
            System.out.println("firstRowIndex: " + firstRowIndex);
            System.out.println("lastRowIndex: " + lastRowIndex);

            for (int rIndex = firstRowIndex; rIndex <= lastRowIndex; rIndex++) {   //遍历行
                Row row = sheet.getRow(rIndex);
                int rowNum = row.getRowNum();
                if (row != null) {
                    FungimycinLimit fungimycinLimit=new FungimycinLimit();

                    //遍历列
                    Cell cell = row.getCell(0);
                    if (cell != null) {
                        Double bb=new Double(cell.getNumericCellValue());
                        fungimycinLimit.setId(bb.intValue());
                        System.out.println(" "+bb);
                    }
                    Cell cell1 = row.getCell(1);
                    if(rIndex==lastRowIndex&&(cell1==null||cell1.toString()==""))continue;
                    if (cell1 != null) {
                        fungimycinLimit.setFungimycinCname(cell1.toString());
                        System.out.println(cell1.toString());
                    }
                    Cell cell2 = row.getCell(2);
                    if (cell2 != null) {
                        fungimycinLimit.setFungimycinEname(cell2.toString());
                        System.out.println(cell2.toString());

                    }
                    Cell cell3 = row.getCell(3);
                    if (cell3 != null) {
                        fungimycinLimit.setFoodName(cell3.toString());
                        System.out.println(cell3.toString());

                    }
                    Cell cell4 = row.getCell(4);
                    if (cell4 != null) {
                        fungimycinLimit.setLimited(cell4.toString());
                        System.out.println(cell4.toString());

                    }
                    Cell cell5 = row.getCell(5);
                    if (cell5 != null) {
                        fungimycinLimit.setCountryPlace(cell5.toString());
                        System.out.println(cell5.toString());

                    }
                    Cell cell6 = row.getCell(6);
                    if (cell6 != null) {
                        fungimycinLimit.setCheckWay(cell6.toString());
                        System.out.println(cell6.toString());

                    }
                    Cell cell7 = row.getCell(7);
                    if (cell7 != null) {
                        fungimycinLimit.setInformationSources(cell7.toString());
                        System.out.println(cell7.toString());

                    }

                    Cell cell8 = row.getCell(8);
                    if (cell8 != null) {
                        fungimycinLimit.setRemarks(cell8.toString());
                        System.out.println(cell8.toString());

                    }

                    list.add(fungimycinLimit);
                }
            }
        }
        return list;
    }
}

