package com.example.demo.service;



import com.example.demo.entity.Additive;
import com.example.demo.entity.Sheet;
import com.example.demo.mapper.AdditiveMapper;
import org.apache.commons.lang.StringUtils;
import org.apache.jasper.tagplugins.jstl.core.If;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class AdditiveService {
    @Autowired
    private AdditiveMapper additiveLimitMapper;
    public List<Additive> findByName(String additiveCname, String foodSortNo) {
        List<Additive> additives=additiveLimitMapper.findAdditiveByAdditiveCname(additiveCname,foodSortNo);
        for(int i = 0;i<additives.size();i++){
            String aa = additives.get(i).getMaxUsage();//得到原始数据

            if(aa.equals("")){
            }
            else if(aa.contains("按生产")){
                additives.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                additives.get(i).setDoseUnit("mg/kg");
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                additives.get(i).setDoseUnit("μg/kg");
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                additives.get(i).setDoseUnit("g/kg");//赋予字段单位
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                additives.get(i).setDoseUnit("mg/L");//赋予字段单位
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }
            else if(aa.contains("mg/份"))
            {
                additives.get(i).setDoseUnit("mg/份");//赋予字段单位
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("mg/份")));//赋予字段数值

            }
            else{
                additives.get(i).setDoseUnit("g/kg");//赋予字段单位
            }

        }
        return  additives;

    }
    public int insertAdditive(Additive additive)
    {
        Additive additives=additiveLimitMapper.judge(additive.getAdditiveCname(),additive.getFoodCname(),additive.getRemarks());
        if(additives!=null)
        {
            additive.setTips("已有数据,请查找后进行编辑");
            return 0;
        }
        if(additive.getFoodSortNo()==null||additive.getFoodCname()==null||additive.getAdditiveCname()==null||additive.getAdditiveEname()==null||additive.getFunction()==null||additive.getMaxUsage()==null||additive.getCountryPlace()==null){
            return 0;
        }
            additive.setTips("新增数据成功");
            additiveLimitMapper.insertAdditive(additive);
            return 1;


    }
    public String match(String food_name,String food_sort_no){
        return additiveLimitMapper.match(food_name,food_sort_no);
    }
    public List<Additive> ListAdditive(){
        List<Additive> additives=additiveLimitMapper.ListAdditive();
        for(int i = 0;i<additives.size();i++){
            String aa = additives.get(i).getMaxUsage();//得到原始数据

            if(aa.equals("")){
            }
            else if(aa.contains("按生产")){
                additives.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                additives.get(i).setDoseUnit("mg/kg");
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                additives.get(i).setDoseUnit("μg/kg");
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                additives.get(i).setDoseUnit("g/kg");//赋予字段单位
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                additives.get(i).setDoseUnit("mg/L");//赋予字段单位
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }
            else if(aa.contains("mg/份"))
            {
                additives.get(i).setDoseUnit("mg/份");//赋予字段单位
                additives.get(i).setMaxUsage(aa.substring(0,aa.lastIndexOf("mg/份")));//赋予字段数值

            }
            else{
                additives.get(i).setDoseUnit("g/kg");//赋予字段单位
                }

        }
        return  additives;

    }

    public int Update(Additive additive){
        Additive AA=additiveLimitMapper.findById(additive);//找到要编辑的数据
        //没改关键词,直接修改
        if(AA.getAdditiveCname()==additive.getAdditiveCname()&&AA.getFoodCname()==additive.getFoodCname()&&AA.getRemarks()==additive.getRemarks())
        {
            return additiveLimitMapper.Update(additive);
        }
        //改动关键词
        else {
            //若已存在数据,不做任何操作
            if(additiveLimitMapper.judge(additive.getAdditiveCname(),additive.getFoodCname(),additive.getRemarks())!=null){
                return 0;
            }
            //不存在数据将原先数据覆盖,插入新数据
            else{
                Update2(AA);
                insertAdditive(additive);
                return 1;
            }
        }
    }

    public int Update2(Additive additive){
        return additiveLimitMapper.Update2(additive);
    }
    public void read(){};

    public List<Sheet> getSheet(){
        List<Sheet> rootSheet=additiveLimitMapper.getsheet();//原始数据
        //输出结果用于检查
        for(Sheet sheet: rootSheet){
            System.out.println(sheet);
        }
        // 最后的结果
        List<Sheet> sheetList=new ArrayList<Sheet>();
        for(int i=0;i<rootSheet.size();i++){
            if("peak".equals(rootSheet.get(i).getParentId())){
                sheetList.add(rootSheet.get(i));
            }
        }
        for(Sheet sheet: sheetList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        return  sheetList;

    }
    private  List<Sheet> getChild(String id,List<Sheet> rootSheet){
        List<Sheet> childList=new ArrayList<>();
        for(Sheet sheet: rootSheet){
            if(StringUtils.isNotBlank(sheet.getParentId())){
                if(sheet.getParentId().equals(id)){
                    childList.add(sheet);
                }
            }
        }
        for(Sheet sheet: childList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        if(childList.size()==0){
            return null;
        }
        return childList;
    }
}