package com.example.demo.service;


import com.example.demo.entity.FungimycinLimit;
import com.example.demo.entity.Sheet;

import com.example.demo.mapper.FungimycinLimitMapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class FungimycinLimitService {
    @Autowired
    private FungimycinLimitMapper fungimycinLimitMapper;
    public List<FungimycinLimit> findByName(String fungimycinCname, String food_sort_no) {
        List<FungimycinLimit> fungimycinLimits=fungimycinLimitMapper.findFungimycinByFungimycinCname(fungimycinCname,food_sort_no);
        for(int i = 0;i<fungimycinLimits.size();i++){
            String aa = fungimycinLimits.get(i).getLimited();//得到原始数据

            if(aa.equals("")){
            }
            else if(aa.contains("按生产")){
                fungimycinLimits.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                fungimycinLimits.get(i).setDoseUnit("mg/kg");
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                fungimycinLimits.get(i).setDoseUnit("μg/kg");
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                fungimycinLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                fungimycinLimits.get(i).setDoseUnit("mg/L");//赋予字段单位
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }
            else if(aa.contains("mg/份"))
            {
                fungimycinLimits.get(i).setDoseUnit("mg/份");//赋予字段单位
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/份")));//赋予字段数值

            }
            else{
                fungimycinLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
            }

        }
        return fungimycinLimits ;
    }
    public int insertFungimycinLimit(FungimycinLimit fungimycinLimit)
    {
        FungimycinLimit fungimycinLimits=fungimycinLimitMapper.judge(fungimycinLimit.getFungimycinCname(),fungimycinLimit.getFoodName(),fungimycinLimit.getRemarks());
        if(fungimycinLimits!=null)
        {
            fungimycinLimit.setTips("已有数据,请查找后进行编辑");
            return 0;
        }
        if(fungimycinLimit.getFungimycinEname()==null||fungimycinLimit.getFungimycinCname()==null||fungimycinLimit.getLimited()==null||fungimycinLimit.getCountryPlace()==null){
            return 0;
        }
            fungimycinLimit.setTips("新增数据成功");
            fungimycinLimitMapper.insertFungimycinLimit(fungimycinLimit);
            return 1;

    }

    public List<FungimycinLimit> ListFungimycin(){
        List<FungimycinLimit> fungimycinLimits=fungimycinLimitMapper.ListFungimycin();
        for(int i = 0;i<fungimycinLimits.size();i++){
            String aa = fungimycinLimits.get(i).getLimited();//得到原始数据

            if(aa.equals("")){
            }
            else if(aa.contains("按生产")){
                fungimycinLimits.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                fungimycinLimits.get(i).setDoseUnit("mg/kg");
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                fungimycinLimits.get(i).setDoseUnit("μg/kg");
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                fungimycinLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                fungimycinLimits.get(i).setDoseUnit("mg/L");//赋予字段单位
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }
            else if(aa.contains("mg/份"))
            {
                fungimycinLimits.get(i).setDoseUnit("mg/份");//赋予字段单位
                fungimycinLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/份")));//赋予字段数值

            }
            else{
                fungimycinLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
            }

        }
        return fungimycinLimits ;

    }

    public int Update(FungimycinLimit fungimycinLimit) {
        FungimycinLimit AA = fungimycinLimitMapper.findById(fungimycinLimit);
        if (AA.getFungimycinCname() == fungimycinLimit.getFungimycinCname() && AA.getFoodName() == fungimycinLimit.getFoodName() && AA.getRemarks() == fungimycinLimit.getRemarks()) {
            return fungimycinLimitMapper.Update(fungimycinLimit);
        }
        else{
            if (fungimycinLimitMapper.judge(fungimycinLimit.getFungimycinCname(), fungimycinLimit.getFoodName(), fungimycinLimit.getRemarks()) != null) {
                return 0;
            }
            else {
                Update2(AA);
                insertFungimycinLimit(fungimycinLimit);
                return 1;
            }
        }
    }

    public int delete(String fungimycinCname){
        return fungimycinLimitMapper.delete(fungimycinCname);
    }

    public int Update2(FungimycinLimit fungimycinLimit){
        return fungimycinLimitMapper.Update2(fungimycinLimit);
    }
    public void read(){};

    public List<Sheet> getSheet(){
        List<Sheet> rootSheet=fungimycinLimitMapper.getsheet();//原始数据
        //输出结果用于检查
        for(Sheet sheet: rootSheet){
            System.out.println(sheet);
        }
        // 最后的结果
        List<Sheet> sheetList=new ArrayList<Sheet>();
        for(int i=0;i<rootSheet.size();i++){
            if("peak".equals(rootSheet.get(i).getParentId())){
                sheetList.add(rootSheet.get(i));
            }
        }
        for(Sheet sheet: sheetList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        return  sheetList;

    }
    private  List<Sheet> getChild(String id,List<Sheet> rootSheet){
        List<Sheet> childList=new ArrayList<>();
        for(Sheet sheet: rootSheet){
            if(StringUtils.isNotBlank(sheet.getParentId())){
                if(sheet.getParentId().equals(id)){
                    childList.add(sheet);
                }
            }
        }
        for(Sheet sheet: childList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        if(childList.size()==0){
            return null;
        }
        return childList;
    }
}