package com.example.demo.service;



import com.example.demo.entity.PesticidesLimit;
import com.example.demo.entity.Sheet;

import com.example.demo.mapper.PesticidesLimitMapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class PesticidesLimitService {
    @Autowired
    private PesticidesLimitMapper pesticidesLimitMapper;
    public List<PesticidesLimit> findByName(String pesticidesCname, String food_sort_no) {
        List<PesticidesLimit> pesticidesLimits=pesticidesLimitMapper.findPesticidesByPesticidesCname(pesticidesCname,food_sort_no);
        for(int i = 0;i<pesticidesLimits.size();i++){
            String aa = pesticidesLimits.get(i).getLimited();//得到原始数据

            if(aa==null)
            {}
            else if(aa.contains("量")||aa.contains("可")||aa.contains("脂肪")||aa.contains("肉")||aa.contains("内脏")||aa.contains("原样")||aa.contains("鱼类")||aa.contains("豁免")){
                pesticidesLimits.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                pesticidesLimits.get(i).setDoseUnit("mg/kg");
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                pesticidesLimits.get(i).setDoseUnit("μg/kg");
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                pesticidesLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                pesticidesLimits.get(i).setDoseUnit("mg/L");//赋予字段单位
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }
            else {pesticidesLimits.get(i).setDoseUnit("mg/kg");}
        }
        return  pesticidesLimits;

    }
    public int insertPesticidesLimit(PesticidesLimit pesticidesLimit)
    {
        PesticidesLimit pesticidesLimit1=pesticidesLimitMapper.judge(pesticidesLimit.getPesticidesCname(),pesticidesLimit.getFoodName(),pesticidesLimit.getRemarks());
        if(pesticidesLimit1!=null)
        {
            pesticidesLimit.setTips("已有数据,请查找后进行编辑");
            return 0;
        }
        if(pesticidesLimit.getPesticidesCname()==null||pesticidesLimit.getPesticidesEname()==null||pesticidesLimit.getFoodName()==null||pesticidesLimit.getLimited()==null||pesticidesLimit.getDeterminePlace()==null||pesticidesLimit.getCountryPlace()==null){
            return 0;
        }
        else{
            pesticidesLimit.setTips("新增数据成功");
            pesticidesLimitMapper.insertPesticidesLimit(pesticidesLimit);
            return 1;
        }

    }

    public List<PesticidesLimit> ListPesticides(){
        List<PesticidesLimit> pesticidesLimits=pesticidesLimitMapper.ListPesticides();
        for(int i = 0;i<pesticidesLimits.size();i++){
            String aa = pesticidesLimits.get(i).getLimited();//得到原始数据

            if(aa==null)
            {}
            else if(aa.contains("量")||aa.contains("可")||aa.contains("脂肪")||aa.contains("肉")||aa.contains("内脏")||aa.contains("原样")||aa.contains("鱼类")||aa.contains("豁免")){
                pesticidesLimits.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                pesticidesLimits.get(i).setDoseUnit("mg/kg");
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                pesticidesLimits.get(i).setDoseUnit("μg/kg");
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                pesticidesLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                pesticidesLimits.get(i).setDoseUnit("mg/L");//赋予字段单位
                pesticidesLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }
            else {pesticidesLimits.get(i).setDoseUnit("mg/kg");}
        }
        return  pesticidesLimits;


    }

    public int Update(PesticidesLimit pesticidesLimit) {
        PesticidesLimit AA = pesticidesLimitMapper.findById(pesticidesLimit);
        if (AA.getPesticidesCname() == pesticidesLimit.getPesticidesCname() && AA.getFoodName() == pesticidesLimit.getFoodName() && AA.getRemarks() == pesticidesLimit.getRemarks()) {
            return pesticidesLimitMapper.Update(pesticidesLimit);
        } else {
            if (pesticidesLimitMapper.judge(pesticidesLimit.getPesticidesCname(), pesticidesLimit.getFoodName(), pesticidesLimit.getRemarks()) != null) {
                return 0;
            } else {
                Update2(AA);
                insertPesticidesLimit(pesticidesLimit);
                return 1;
            }
        }
    }

    public int delete(String pesticidesCname){
        return pesticidesLimitMapper.delete(pesticidesCname);
    }

    public int Update2(PesticidesLimit pesticidesLimit){
        return pesticidesLimitMapper.Update2(pesticidesLimit);
    }
    public void read(){};

    public List<Sheet> getSheet(){
        List<Sheet> rootSheet=pesticidesLimitMapper.getsheet();//原始数据
        //输出结果用于检查
        for(Sheet sheet: rootSheet){
            System.out.println(sheet);
        }
        // 最后的结果
        List<Sheet> sheetList=new ArrayList<Sheet>();
        for(int i=0;i<rootSheet.size();i++){
            if("peak".equals(rootSheet.get(i).getParentId())){
                sheetList.add(rootSheet.get(i));
            }
        }
        for(Sheet sheet: sheetList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        return  sheetList;

    }
    private  List<Sheet> getChild(String id,List<Sheet> rootSheet){
        List<Sheet> childList=new ArrayList<>();
        for(Sheet sheet: rootSheet){
            if(StringUtils.isNotBlank(sheet.getParentId())){
                if(sheet.getParentId().equals(id)){
                    childList.add(sheet);
                }
            }
        }
        for(Sheet sheet: childList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        if(childList.size()==0){
            return null;
        }
        return childList;
    }
}