package com.example.demo.service;
import java.util.ArrayList;
import java.util.List;

import com.example.demo.entity.Sheet;
import org.apache.commons.lang.StringUtils;
import org.apache.jasper.tagplugins.jstl.core.If;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.example.demo.entity.PollutantLimit;
import com.example.demo.mapper.PollutantLimitMapper;
@Service
public class PollutantLimitService {
    @Autowired
    private PollutantLimitMapper pollutantLimitMapper;
    public List<PollutantLimit> findByName(String pollutant_cname,String food_sort_no) {
        List<PollutantLimit> pollutantLimits=pollutantLimitMapper.findUserBypollutant_cname(pollutant_cname,food_sort_no);
        for(int i = 0;i<pollutantLimits.size();i++){
            String aa = pollutantLimits.get(i).getLimited();//得到原始数据

            if(aa.contains("液态")||aa.contains("固态")||aa.contains("鱼类")){
                pollutantLimits.get(i).setDoseUnit("");
            }
             else if(aa.contains("mg/kg")){
                pollutantLimits.get(i).setDoseUnit("mg/kg");
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                pollutantLimits.get(i).setDoseUnit("μg/kg");
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                pollutantLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
            else if (aa.contains("mg/L"))
            {
                pollutantLimits.get(i).setDoseUnit("mg/L");//赋予字段单位
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/L")));//赋予字段数值
            }

        }
        return  pollutantLimits;

    }
    public int insertPollutantLimit(PollutantLimit pollutantLimit) {
        PollutantLimit pollutantLimits=pollutantLimitMapper.judge(pollutantLimit.getPollutant_cname(),pollutantLimit.getFood_name(),pollutantLimit.getRemarks());
        if(pollutantLimits!=null)
        {
            pollutantLimit.setTips("已有数据,请查找后进行编辑");
            return 0;
        }
        if(pollutantLimit.getPollutant_cname()==null||pollutantLimit.getPollutant_ename()==null||pollutantLimit.getLimited()==null||pollutantLimit.getCountry_place()==null){
            return 0;
        }
            pollutantLimitMapper.insertPollutantLimit(pollutantLimit);
            return 1;
        }



    public List<PollutantLimit> ListUser(){
        List<PollutantLimit> pollutantLimits=pollutantLimitMapper.ListUser();
        for(int i = 0;i<pollutantLimits.size();i++){
            String aa = pollutantLimits.get(i).getLimited();//得到原始数据

            if(aa==null)
            {}
            else if(aa.contains("液态")||aa.contains("固态")){
                pollutantLimits.get(i).setDoseUnit("");
            }
            else if(aa.contains("mg/kg")){
                pollutantLimits.get(i).setDoseUnit("mg/kg");
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("mg/kg")));

            }
            else if(aa.contains("μg/kg")){
                pollutantLimits.get(i).setDoseUnit("μg/kg");
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("μg/kg")));

            }
            else if (aa.contains("g/kg"))
            {
                pollutantLimits.get(i).setDoseUnit("g/kg");//赋予字段单位
                pollutantLimits.get(i).setLimited(aa.substring(0,aa.lastIndexOf("g/kg")));//赋予字段数值
            }
        }
        return  pollutantLimits;
    }

    public int Update(PollutantLimit pollutantLimit){
       PollutantLimit AA=pollutantLimitMapper.findById(pollutantLimit);
       if(AA.getPollutant_cname()==pollutantLimit.getPollutant_cname()&&AA.getFood_name()==pollutantLimit.getFood_name()&&AA.getRemarks()==pollutantLimit.getRemarks())
       {
           return pollutantLimitMapper.Update(pollutantLimit);
       }
       else {
           if(pollutantLimitMapper.judge(pollutantLimit.getPollutant_cname(),pollutantLimit.getFood_name(),pollutantLimit.getRemarks())!=null){
               return 0;
           }
           else{
               Update2(AA);
               insertPollutantLimit(pollutantLimit);
               return 1;
           }
       }

    }

    public int delete(String pollutant_cname){
        return pollutantLimitMapper.delete(pollutant_cname);
    }

    public int Update2(PollutantLimit pollutantLimit){
        return pollutantLimitMapper.Update2(pollutantLimit);
    }
    public void read(){};

    public List<Sheet> getSheet(){
        List<Sheet> rootSheet=pollutantLimitMapper.getsheet();//原始数据
        //输出结果用于检查
        for(Sheet sheet: rootSheet){
            System.out.println(sheet);
        }
        // 最后的结果
        List<Sheet> sheetList=new ArrayList<Sheet>();
        for(int i=0;i<rootSheet.size();i++){
            if("peak".equals(rootSheet.get(i).getParentId())){
                sheetList.add(rootSheet.get(i));
            }
        }
        for(Sheet sheet: sheetList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        return  sheetList;

    }
    private  List<Sheet> getChild(String id,List<Sheet> rootSheet){
        List<Sheet> childList=new ArrayList<>();
        for(Sheet sheet: rootSheet){
            if(StringUtils.isNotBlank(sheet.getParentId())){
                if(sheet.getParentId().equals(id)){
                    childList.add(sheet);
                }
            }
        }
        for(Sheet sheet: childList){
            sheet.setChildren(getChild(sheet.getValue(),rootSheet));
        }
        if(childList.size()==0){
            return null;
        }
        return childList;
    }
}